【小白学C#】谈谈C#多播委托因异常而终止的解决方案

一、前言

  前几天,马三在与朋友闲聊技术的时候,朋友忽然抛出一个问题,把马三难倒了,本着求知的精神,回来以后马三就查阅了相关资料并做了一些实验,终于把问题搞明白了,因此写下本篇博客记录一下。首先,问题是这样的:“C#中有多播委托,那么在使用多播委托时,假设方法列表中有多个方法,但委托执行到某个方法时抛出异常,那么整个委托的迭代是否会终止呢?如果终止的话,可以使用什么方法容错,使整个委托链中的方法继续执行呢?如果把多播委托换成事件,那么又会有怎么样的效果呢?”。

  在开始正文之前,还是先公布一下答案吧:

  1.C#多播委托执行到某个方法抛出异常的时候,整个委托的迭代将在抛出异常的地方退出终止,后面的方法就不会再去执行了;

  2.可以通过自己设计迭代方法来容错,起到即使抛出异常,委托链也不会中止执行的效果;

  3.事件与多播委托的效果一样;

二、前提知识

  按照惯例,我们还是先来熟悉一些前提知识以便于我们对后面概念的理解。

1.委托与事件

  委托与事件早已是老生常谈了,相信做过C#开发的同学一定没少了用它们,网上也有很多把委托和事件分析得很透彻的文章,马三在这里推荐一篇感觉不错的文章—— 张子阳《C#中的委托和事件》

2.多播委托与委托链

  相信大家也或多或少地使用过多播委托,即一个委托可以包含多个方法,当调用该委托的时候,将会依次执行委托链中的方法。而委托链也是一个委托,只是它是把多个委托链在了一起,里面存储着多个委托的引用。可以说,委托链是实现多播委托的途径,多播委托是委托链实现的效果。

  

  图1:委托链示意图

三、实例与分析

  下面我们结合代码来验证与分析一下上面的结论,首先还是先上一下代码:

  先定义一个具有具体方法的类 MultiDelegate,一会我们的委托将会调用这里面的方法:

    class MultiDelegate
    {
        /// <summary>
        /// 会抛出异常的方法1
        /// </summary>
        public static void Func1()
        {
            Console.WriteLine("方法1,会抛出异常!");
            throw new Exception("抛出异常!");
        }

        /// <summary>
        /// 正常方法2
        /// </summary>
        public static void Func2()
        {
            Console.WriteLine("方法2");
        }

    }

  然后我们直接在Main方法中定义并调用多播委托,然后观察结果:

//创建多播委托
multiDelegate = MultiDelegate.Func1;
multiDelegate += MultiDelegate.Func2;

//调用委托,观察结果
try
{
    multiDelegate();
}
catch (Exception e)
{
    Console.WriteLine(e);
}

  结果如下,可以看到在调用Func1方法以后抛出了异常,整个委托的迭代在此处终止,后面的Func2也不再执行了。

  

  图2:多播委托遇到异常终止执行

  为了避免这种情况的发生,使得我们的程序具有一定的容错机制。即使在委托抛出异常的时候,后面的方法依旧可以执行,我们需要自定义一个委托方法列表的迭代方法。众所周知,委托本质上也是一个类,而Delegate类定义了GetInvocationList()方法,它返回Delegate的委托链中的对象数组。我们可以通过这个方法拿到委托链中的对象,然后建立自己的迭代方法,从而解决多播委托在抛出异常后终止的问题,具体的代码如下:

//手动迭代委托方法列表,可以处理抛出异常后委托链终止执行的问题
//定义方法列表数组,使用GetInvocationList()  
//注意使用的是Delegate类,不是delegate关键字  
Delegate[] myDelegates = multiDelegate.GetInvocationList();
foreach (var @delegate in myDelegates)
{
    var delegateItem = (Action) @delegate;
    //分别调用委托
    try
    {
        delegateItem();
    }
    catch (Exception e)
    {
        Console.WriteLine(e);
    }
}

  关于代码的解释和一些要注意的地方已经在注释里面标明了,它的执行效果如下图所示:

  

  图3:自定义多播委托的迭代方法

  事件可以理解为委托的一个实例化对象,通过+=和-=我们可以注册或者反注册一个Handler,它的内部也是使用委托来实现的。事件和多播委托的效果在异常处理上面是一样的,即遇到异常的时候,后面的方法也会终止执行,我们也可以通过和委托一样的方法来自定义委托链迭代方法来解决这个问题,具体的代码如下:

//依次注册事件
            multiEvent += MultiDelegate.Func1;
            multiEvent += MultiDelegate.Func2;

            //调用事件,观察结果
            try
            {
                multiEvent();
            }
            catch (Exception e)
            {
                Console.WriteLine(e);
            }

            Console.WriteLine("---------------------------分割线------------------------------");
            //手动迭代委托方法列表,可以处理抛出异常后委托链终止执行的问题
            //定义方法列表数组,使用GetInvocationList()  
            //注意使用的是Delegate类,不是delegate关键字  

            Delegate[] myDelegates = multiEvent.GetInvocationList();
            foreach (var @delegate in myDelegates)
            {
                var delegateItem = @delegate as Action;
                try
                {
                    delegateItem();
                }
                catch (Exception e)
                {
                    Console.WriteLine(e);
                }
            }

  其实利用上面的方法我们还可以实现其他的很多效果,比如说获取并处理多播委托的返回值。在我们调用一个多播委托的时候,其返回值一般都是委托链中的最后一个方法的返回值,比如有Method1 返回1,Method2返回2,当我们把他们都注册到一个多播委托上并调用的时候,我们会得到一个结果为2的返回值。下面的代码演示了如何获取并处理多播委托的委托链中的每个方法的返回值:

/// <summary>
/// 带有返回值的函数
/// </summary> /// <returns></returns>
public static int GetOne() {   return 1; } /// <summary> /// 带有返回值的函数 /// </summary> /// <returns></returns> public static int GetTwo() {   return 2; }
getResultDelegate = MultiDelegate.GetOne;
getResultDelegate += MultiDelegate.GetTwo;

Console.WriteLine("直接调用委托返回的一般是最后一个方法的返回值:" + getResultDelegate());

//手动迭代委托方法列表,可以获取并处理每个委托的返回值
//定义方法列表数组,使用GetInvocationList()  
//注意使用的是Delegate类,不是delegate关键字 
int sum = 0;
Delegate[] resultDelegates = getResultDelegate.GetInvocationList();
foreach (var @delegate in resultDelegates)
{
    var delegateItem = @delegate as GetResult;
    sum += delegateItem();
    Console.WriteLine("获取单个委托的返回值:" + delegateItem());
}
Console.WriteLine("多个委托的返回值总和:" + sum);

  代码的执行结果如下,我们一次获取并打印了委托链中每个方法的返回值,并对它们进行了求和:

  

  图4:处理多播委托的返回值

四、总结

  文章的最后我们再来总结一下:C#多播委托执行到某个方法抛出异常的时候,整个委托的迭代将在抛出异常的地方退出终止,后面的方法就不会再去执行了;可以通过自己设计迭代方法来容错,起到即使抛出异常,委托链也不会中止执行的效果;事件与多播委托的效果一样。

  本篇博客中的代码已经通过到Github:https://github.com/XINCGer/Unity3DTraining/tree/master/SomeTest/MultiDelegateException   欢迎fork!

 

 

 

作者:马三小伙儿
出处:http://www.cnblogs.com/msxh/p/8625586.html 
请尊重别人的劳动成果,让分享成为一种美德,欢迎转载。另外,文章在表述和代码方面如有不妥之处,欢迎批评指正。留下你的脚印,欢迎评论!

posted @ 2018-03-23 20:50  马三小伙儿  阅读(2389)  评论(5编辑  收藏  举报